| Version: 3.3.1

Public Member Functions | Static Public Member Functions | List of all members
wxProcess Class Reference
Class List by Category » Application and Process Management

`#include <wx/process.h>`

Inheritance diagram for wxProcess:
[legend]

## Detailed Description

The objects of this class are used in conjunction with the wxExecute() function.

When a wxProcess object is passed to wxExecute(), its OnTerminate() virtual method is called when the process terminates. This allows the program to be (asynchronously) notified about the process termination and also retrieve its exit status which is unavailable from wxExecute() in the case of asynchronous execution.

Note
  If the `wxEVT_END_PROCESS` event sent after termination is processed by the parent, then it is responsible for deleting the wxProcess object which sent it. However, if it is not processed, the object will delete itself and so the library users should only delete those objects whose notifications have been processed (and call wxProcess::Detach for others). This also means that unless you're going to process the `wxEVT_END_PROCESS` event, you must allocate the wxProcess class on the heap.

wxProcess also supports IO redirection of the child process. For this, you have to call its Redirect() method before passing it to wxExecute(). If the child process was launched successfully, GetInputStream(), GetOutputStream() and GetErrorStream() can then be used to retrieve the streams corresponding to the child process standard output, input and error output respectively.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxProcessEvent& event)

Event macros for events emitted by this class:

- EVT_END_PROCESS(id, func):
  Process a `wxEVT_END_PROCESS` event, sent by wxProcess::OnTerminate upon the external process termination.

##

Library: wxBase
Category: Application and Process Management

wxPerl Note: In wxPerl this class has an additional `Destroy` method, for explicit destruction.

See also
  wxExecute(), External Program Execution Sample

## Public Member Functions
| wxProcess (wxEvtHandler *parent=nullptr, int id=-1)
| Constructs a process object. More...
| wxProcess (int flags)
| Creates an object without any associated parent (and hence no id either) but allows specifying the flags which can have the value of `wxPROCESS_DEFAULT` or `wxPROCESS_REDIRECT`. More...
virtual | ~wxProcess ()
| Destroys the wxProcess object. More...
bool | Activate () const
| Activates a GUI process by bringing up its main window to the front. More...
void | CloseOutput ()
| Closes the output stream (the one connected to the stdin of the child process). More...
void | Detach ()
| Detaches this event handler from the parent specified in the constructor (see wxEvtHandler::Unlink() for a similar but not identical function). More...
wxInputStream * | GetErrorStream () const
| Returns an input stream which corresponds to the standard error output (stderr) of the child process. More...
wxInputStream * | GetInputStream () const
| It returns an input stream corresponding to the standard output stream of the subprocess. More...
wxOutputStream * | GetOutputStream () const
| It returns an output stream corresponding to the input stream of the subprocess. More...
long | GetPid () const
| Returns the process ID of the process launched by Open() or set by wxExecute() (if you passed this wxProcess as argument). More...
bool | IsErrorAvailable () const
| Returns true if there is data to be read on the child process standard error stream. More...
bool | IsInputAvailable () const
| Returns true if there is data to be read on the child process standard output stream. More...
bool | IsInputOpened () const
| Returns true if the child process standard output stream is opened. More...
virtual void | OnTerminate (int pid, int status)
| It is called when the process with the pid pid finishes. More...
void | Redirect ()
| Turns on redirection. More...
void | SetPriority (unsigned priority)
| Sets the priority of the process, between 0 (lowest) and 100 (highest). More...
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor. More...
virtual | ~wxEvtHandler ()
| Destructor. More...
virtual void | QueueEvent (wxEvent *event)
| Queue event for a later processing. More...
virtual void | AddPendingEvent (const wxEvent &event)
| Post an event to be processed later. More...
template<typename T , typename T1 , ... >
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method. More...
template<typename T >
void | CallAfter (const T &functor)
| Asynchronously call the given functor. More...
virtual bool | ProcessEvent (wxEvent &event)
| Processes an event, searching event tables and calling zero or more suitable event handler function(s). More...
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it. More...
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process. More...
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail. More...
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent(). More...
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| Connects the given function dynamically with the event handler, id and event type. More...
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=nullptr, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=nullptr, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
template<typename EventTag , typename Functor >
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| Binds the given function, functor or method dynamically with the event. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
template<typename EventTag , typename Functor >
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
void * | GetClientData () const
| Returns user-supplied client data. More...
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object. More...
void | SetClientData (void *data)
| Sets user-supplied client data. More...
void | SetClientObject (wxClientData *data)
| Set the client data object. More...
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise. More...
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain. More...
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain. More...
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler. More...
virtual void | SetNextHandler (wxEvtHandler *handler)
| Sets the pointer to the next handler. More...
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| Sets the pointer to the previous handler. More...
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted). More...
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are nullptr. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Static Public Member Functions
static bool | Exists (int pid)
| Returns true if the given process exists in the system. More...
static wxKillError | Kill (int pid, wxSignal sig=wxSIGTERM, int flags=wxKILL_NOCHILDREN)
| Send the specified signal to the given process. More...
static wxProcess * | Open (const wxString &cmd, int flags=wxEXEC_ASYNC)
| This static method replaces the standard `popen()` function: it launches the process specified by the cmd parameter and returns the wxProcess object which can be used to retrieve the streams connected to the standard input, output and error output of the child process. More...
Static Public Member Functions inherited from wxEvtHandler
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets. More...
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter(). More...

## Additional Inherited Members
Protected Member Functions inherited from wxEvtHandler
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables. More...
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort. More...
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxProcess() [1/2]

wxProcess::wxProcess | ( | wxEvtHandler * | parent = `nullptr`,
|  | int | id = `-1`
| ) |  |

Constructs a process object.

id is only used in the case you want to use wxWidgets events. It identifies this object, or another window that will receive the event.

If the parent parameter is different from nullptr, it will receive a `wxEVT_END_PROCESS` notification event (you should insert `EVT_END_PROCESS` macro in the event table of the parent to handle it) with the given id.

Parameters

  parent | The event handler parent.
  id | id of an event.

## ◆ wxProcess() [2/2]

wxProcess::wxProcess | ( | int | flags | ) |

Creates an object without any associated parent (and hence no id either) but allows specifying the flags which can have the value of `wxPROCESS_DEFAULT` or `wxPROCESS_REDIRECT`.

Specifying the former value has no particular effect while using the latter one is equivalent to calling Redirect().

## ◆ ~wxProcess()

virtual wxProcess::~wxProcess | ( |  | ) |
| virtual

Destroys the wxProcess object.

## Member Function Documentation

## ◆ Activate()

bool wxProcess::Activate | ( |  | ) | const

Activates a GUI process by bringing up its main window to the front.

This is a convenient method which tries to bring this process to the users attention.

Currently this is implemented in wxMSW only and simply returns false under the other platforms. Notice that this function can also return false under MSW if, for example, the process doesn't have any windows.

Since
  3.1.0

## ◆ CloseOutput()

void wxProcess::CloseOutput | ( |  | ) |

Closes the output stream (the one connected to the stdin of the child process).

This function can be used to indicate to the child process that there is no more data to be read - usually, a filter program will only terminate when the input stream is closed.

Notice that GetOutputStream() will return nullptr after the output stream is closed.

## ◆ Detach()

void wxProcess::Detach | ( |  | ) |

Detaches this event handler from the parent specified in the constructor (see wxEvtHandler::Unlink() for a similar but not identical function).

Normally, a wxProcess object is deleted by its parent when it receives the notification about the process termination.

However, it might happen that the parent object is destroyed before the external process is terminated (e.g. a window from which this external process was launched is closed by the user) and in this case it should not delete the wxProcess object, but should call Detach() instead.

After the wxProcess object is detached from its parent, no notification events will be sent to the parent and the object will delete itself upon reception of the process termination notification.

## ◆ Exists()

static bool wxProcess::Exists | ( | int | pid | ) |
| static

Returns true if the given process exists in the system.

See also
  Kill(), Exec sample

## ◆ GetErrorStream()

wxInputStream* wxProcess::GetErrorStream | ( |  | ) | const

Returns an input stream which corresponds to the standard error output (stderr) of the child process.

## ◆ GetInputStream()

wxInputStream* wxProcess::GetInputStream | ( |  | ) | const

It returns an input stream corresponding to the standard output stream of the subprocess.

If it is nullptr, you have not turned on the redirection.

See also
  Redirect().

## ◆ GetOutputStream()

wxOutputStream* wxProcess::GetOutputStream | ( |  | ) | const

It returns an output stream corresponding to the input stream of the subprocess.

If it is nullptr, you have not turned on the redirection or already called CloseOutput().

See also
  Redirect().

## ◆ GetPid()

long wxProcess::GetPid | ( |  | ) | const

Returns the process ID of the process launched by Open() or set by wxExecute() (if you passed this wxProcess as argument).

## ◆ IsErrorAvailable()

bool wxProcess::IsErrorAvailable | ( |  | ) | const

Returns true if there is data to be read on the child process standard error stream.

See also
  IsInputAvailable()

## ◆ IsInputAvailable()

bool wxProcess::IsInputAvailable | ( |  | ) | const

Returns true if there is data to be read on the child process standard output stream.

This allows writing simple (and extremely inefficient) polling-based code waiting for a better mechanism in future wxWidgets versions. See the exec sample for an example of using this function.

See also
  IsInputOpened()

## ◆ IsInputOpened()

bool wxProcess::IsInputOpened | ( |  | ) | const

Returns true if the child process standard output stream is opened.

## ◆ Kill()

static wxKillError wxProcess::Kill | ( | int | pid,
|  | wxSignal | sig = `wxSIGTERM`,
|  | int | flags = `wxKILL_NOCHILDREN`
| ) |  |
| static

Send the specified signal to the given process.

Possible signal values can be one of the wxSignal enumeration values.

`wxSIGNONE`, `wxSIGKILL` and `wxSIGTERM` have the same meaning under both Unix and Windows but all the other signals are equivalent to `wxSIGTERM` under Windows.

The flags parameter can be `wxKILL_NOCHILDREN` (the default), or `wxKILL_CHILDREN`, in which case the child processes of this process will be killed too. Note that under Unix, for `wxKILL_CHILDREN` to work you should have created the process passing `wxEXEC_MAKE_GROUP_LEADER`.

Returns the element of wxKillError enum.

See also
  Exists(), wxKill(), Exec sample

## ◆ OnTerminate()

virtual void wxProcess::OnTerminate | ( | int | pid,
|  | int | status
| ) |  |
| virtual

It is called when the process with the pid pid finishes.

It raises a wxWidgets event when it isn't overridden.

Note that this function won't be called if you Kill() the process.

Parameters

  pid | The pid of the process which has just terminated.
  status | The exit code of the process.

## ◆ Open()

static wxProcess* wxProcess::Open | ( | const wxString & | cmd,
|  | int | flags = `wxEXEC_ASYNC`
| ) |  |
| static

This static method replaces the standard `popen()` function: it launches the process specified by the cmd parameter and returns the wxProcess object which can be used to retrieve the streams connected to the standard input, output and error output of the child process.

If the process couldn't be launched, nullptr is returned.

Remarks
  In any case the returned pointer should not be deleted, rather the process object will be destroyed automatically when the child process terminates. This does mean that the child process should be told to quit before the main program exits to avoid memory leaks.

Parameters

  cmd | The command to execute, including optional arguments.
  flags | The flags to pass to wxExecute(). Note: `wxEXEC_SYNC` should not be used.

Returns
  A pointer to new wxProcess object or nullptr on error.

See also
  wxExecute()

## ◆ Redirect()

void wxProcess::Redirect | ( |  | ) |

Turns on redirection.

wxExecute() will try to open a couple of pipes to catch the subprocess stdio. The caught input stream is returned by GetOutputStream() as a non-seekable stream. The caught output stream is returned by GetInputStream() as a non-seekable stream.

## ◆ SetPriority()

void wxProcess::SetPriority | ( | unsigned | priority | ) |

Sets the priority of the process, between 0 (lowest) and 100 (highest).

It can only be set before the process is created.

The following symbolic constants can be used in addition to raw values in 0..100 range:

- wxPRIORITY_MIN: 0
- wxPRIORITY_DEFAULT: 50
- wxPRIORITY_MAX: 100

Since
  2.9.5